#![feature(never_type, lint_reasons)]

use std::ops::Range;

use args::Args;
use clap::Parser;
use evaluator::{EvalConfig, Evaluator};

mod args;
mod builtins;
mod error;
mod evaluator;

#[allow(clippy::indexing_slicing, reason = "in logos, outside our control")]
mod lexer;

mod namespace;
mod syntax;
mod typed;

// basically logos::Span but in this repo
type Span = Range<usize>;

fn main() {
    let args = Args::parse();

    let mut evaluator = Evaluator::init(EvalConfig::new(args.debug_tokens, args.debug_typed_repr));

    evaluator.run(args.text, None);
    evaluator.next();
}
